﻿import flash.display.BitmapData;
import flash.geom.Rectangle;
import flash.geom.Matrix;
import flash.geom.ColorTransform;
import flash.filters.ConvolutionFilter;
import flash.geom.Point;
class VideoManager {
	var engine;
	var previousCommands:Array
	//comand = {name:str,params:[]}
	var postCommands:Array
	var bd:BitmapData
	var outputs = new Array()
	var supply:MovieClip
	var MA:Matrix
	var CM:ColorTransform
	var modeRender="normal"
	var RE:Rectangle
	var PO:Point
	var renderNormal:Boolean = true
	var colorBase
	var buffers:Object
	function VideoManager(su, en, w,h, alpha, color){
		supply=su
		engine = en
		previousCommands = new Array()
		postCommands = new Array()
		bd = new BitmapData(w,h, alpha, color);
		outputs = new Array()
		MA = new Matrix()
		RE = new Rectangle(0,0,w,h)
		CM = new ColorTransform()
		PO = new Point(0,0)
		colorBase = color
		buffers = new Object()
		bd.draw(supply, MA, CM, modeRender, RE)
	}
	function addOutput (mc:MovieClip) {
		outputs.push(mc)
		mc.attachBitmap(bd,mc.getNextHighestDepth())
	}
	function addPrev (cmd) {
		previousCommands.push(cmd)
	}
	function clrPrev () {
		previousCommands = new Array()
	}
	function addPost (cmd) {
		postCommands.push(cmd)
	}
	function clrPost () {
		postCommands = new Array()
	}
	function render () {
		engine.render()
		for (var i = 0;i<previousCommands.length;i++) {
			run(previousCommands[i])
		}
		if (renderNormal) {
			drawRender()
		}
		for (var i = 0;i<postCommands.length;i++) {
			run(postCommands[i])
		}
	}
	function run (cmd) {
		this[cmd.name](cmd.params)
	}
	function colorTrans (p) {
		if (p[1]==null||p[1]==undefined) {
			bd.colorTransform(bd.rectangle, p[0])
		} else {
			buffers[p[1]].colorTransform(bd.rectangle, p[0])
		}

		
	}
	function applyFilter (p) {
		if (p[1]==null||p[1]==undefined) {
			bd.applyFilter(bd,RE,PO,p[0])
		} else {
			buffers[p[1]].applyFilter(bd,RE,PO,p[0])
		}
	}
	function clear (p) {
		if (p[0]==null||p[0]==undefined) {
			bd.fillRect(RE,colorBase)
		}else{
			buffers[p[0]].fillRect(RE,colorBase)
		}
	}
	function drawRender () {
		bd.draw(supply, MA, CM, modeRender, RE)
	}
	function createBuffer (indice) {
		buffers[indice]= new BitmapData(bd.width, bd.height,true, colorBase);
	}

	function saveRender (p) {
		//lo envia al buffer
		buffers[p[0]].draw(supply, MA, CM, p[1], RE)
	}
	function drawFromBuffer (p) {
		bd.draw(buffers[p[0]],MA,CM,p[1],RE)
	}
	function drawImage (p) {
		bd.draw(p[0],MA,CM,p[1],RE)
	}

	//tengo que hacer todas las operaciones posibles sobre un bitmap
}