﻿/*******************
ENGLISH
project: 3d engine
by: ivan ivanoff (www.i2off.org)
based on the work made by : stuart schoneveld (www.illogicz.com) 
email: avatar@i2off.org
apologies:
	to my wife and kids for supporting me.
	to jorge, valerialaura & mariano, for bothering them all the time.
	thx to valerialaura for the english translation
--------------------
ABOUT THIS CLASS
it controls the position of a given point when a model rotates or moves
--------------------
HOW TO USE
-when you instance this class you have to pass it the position it will have on the three axis

model.addCoord(new Coord(50,50, 0))

///////////////////////////////
ESPANOL
proyecto: engine 3d
por: ivan ivanoff (www.i2off.org)
basado en el trabajo de: stuart schoneveld (www.illogicz.com) 
email: avatar@i2off.org
perdones:
	A mi mujer e hijos por aguantar.
	A jorge, valeria y mariano, por joderlos a cada rato.	
--------------------
ACERCA DE ESTA CLASE
Esta lleva el control de posicion de un punto determinado cuando rota o se mueve un modelo.
--------------------

MODO DE USO
-cuando se construye una instancia de esta clase hay que pasarle como parametro la posicion sobre cada uno de los ejes
por ejemplo:

model.addCoord(new Coord(50,50, 0))

*******************/


class Coord {
	var x
	var y
	var z
	var mx
	var my
	var mz
	var wx
	var wy
	var wz
	var xsin
	var xcos
	var ysin
	var ycos
	var zsin
	var zcos
	var parent:Object
	var _id //se lo entrega el model cuando da el add
	function Coord (xp,yp,zp) {
		x = xp
		y = yp
		z = zp
	}
	function modelMoved () {
		 var p = parent
		 setWorldCoordinates(p.x+mx,p.y+my,p.z+mz)
	}
	function modelRotated () {
		var p = parent
		if(parent.isLinked){
			var xx = p.linkedModel.xrot-p.linkedTrans.rx+p.ixrot
			var yy = p.linkedModel.yrot-p.linkedTrans.ry+p.iyrot
			var zz = p.linkedModel.zrot-p.linkedTrans.rz+p.izrot
		}else{
			var xx = p.ixrot
			var yy = p.iyrot
			var zz = p.izrot
		}
		//setRotation(xx, yy, p.izrot)
		setRotation(xx, yy, zz)
		
	}
	function update (){
		modelRotated()
	}
	function setCoordinates (px,py,pz) {
		x = px
		y = py
		z = pz
		

		setRotation(parent.xrot, parent.yrot, parent.zrot);
	}
	function getCoordinates () {
		return {x:x,y:y,z:z}
	}
	function setModelCoordinates (px,py,pz) {
		mx = px
		my = py
		mz = pz
		var p = parent
		setWorldCoordinates(p.x+px,p.y+py, p.z+pz)
	}
	function getModelCoordinates () {
		return {x:mx,y:my, z:mz}
	}
	function setWorldCoordinates (px,py,pz) {
		wx = px
		wy = py
		wz = pz
	}
	function setRotation (rx,ry, rz) {
		//var xsin = Math.sin(x);
	   //var xcos = Math.cos(x);
	//var ysin = Math.sin(y);
	//var ycos = Math.cos(y);
	//x
	//var z = xcos * this.z - xsin * this.y;
	//var y = xcos * this.y + xsin * this.z;
	// y
	//var x = ycos * this.x - ysin * z;
	//var z = ycos * z + ysin * this.x;
	

		var xsin = Math.sin(rx)
		var xcos = Math.cos(rx)
		var ysin = Math.sin(ry)
		var ycos = Math.cos(ry)
		var zsin = Math.sin(rz)
		var zcos = Math.cos(rz)
		//x
		/*var zT = xcos*z-xsin*y
		var yT = xcos*y+ xsin*z
		//y
		var xT = ycos*x-ysin*zT
		var zT = ycos *zT + ysin*x
		
		var yT = zcos*zT-zsin*yT
		//var xT = zcos*zT-zsin*zT
		//var zT = zcos *zT + zsin*yT+ zsin*xT
		var zT = zcos *xT + zcos*yT+ zsin*zT*/
				// rotation around x
				var xy,xz,yz,yx,zx,zy
		xy = xcos*y - xsin*z;
		xz = xsin*y + xcos*z;
		// rotation around y
		yz = ycos*xz - ysin*x;
		yx = ysin*xz + ycos*x;
		// rotation around z
		zx = zcos*yx - zsin*xy;
		zy = zsin*yx + zcos*xy;
		//setModelCoordinates(xT,yT,zT)

		setModelCoordinates(zx,zy,yz*-1)
	}

}
