﻿import flash.filters.BlurFilter;
import flash.filters.GlowFilter;
class ParticleSystem {
	var x = 0;
	var y = 0;
	var z = 0;
	var rx = 0;
	var ry = 0;
	var rz = 0;
	var minX = 0;
	var maxX = 10;
	var acelX = 0.99;
	var magnetoX = 0.9;
	var minZ = 0;
	var maxZ = 10;
	var acelZ = 0.99;
	var magnetoZ = 0.9;
	var minY = 1;
	var maxY = 5;
	var acelY = 0;
	var magnetoY = 1;
	var _particulas:Object;
	var _total = 0;
	var _max = 10;
	var _ids = 0;
	var _frecuencia = 0;
	//cada cuantos frames lanza una particula
	var _fracuencia_step = 0;
	var _grav = 0.1;
	var main:MovieClip;
	var minLife = 50;
	var maxLife = 80;
	var _icon = "icon2";
	//
	var isLinked = false;
	var linkedModel:Object;
	var linkedTrans:Object;
	var blendMode = 0;
	var filterArray;
	var doGlow = false;
	var doBlur = false;
	var _id;
	var _idNUM;
	var doOnAudioModo2 = false;
	var doOnEveryFrame = true;
	var doOnAudioModo1 = false;
	function ParticleSystem(m) {
		_particulas = {};
		main = m;
		filterArray = new Array();
	}
	function render() {
		var e = false;
		if (_global.FLAXUS_ONMODOAUDIO2 == true && doOnAudioModo2) {
			e = true;
		}
		if (_global.FLAXUS_ONMODOAUDIO1 == true && doOnAudioModo1) {
			e = true;
		}
		if (doOnEveryFrame) {
			e = true;
		}
		if (e) {
			if (_fracuencia_step>=_frecuencia) {
				if (_total<_max) {
					_fracuencia_step = 0;
					newParticle();
				}
			} else {
				_fracuencia_step++;
			}
		}
	}
	function setGlow(color, alpha, blurX, blurY, strength, quality, inner, knockout) {
		var filter:GlowFilter = new GlowFilter(color, alpha, blurX, blurY, strength, quality, inner, knockout);
		//var filterArray:Array = new Array();
		filterArray.push(filter);
		doGlow = true;
	}
	function setBlur(blurX, blurY, quality) {
		var filter:BlurFilter = new BlurFilter(blurX, blurY, quality);
		//var filterArray:Array = new Array();
		filterArray.push(filter);
		doBlur = true;
	}
	function newParticle() {
		var m = main.addModel(_root.icono(_icon));
		//var m = e.addModel(_root.cuadrado(0));
		m.setCoordinates(x, y, z);
		m.rotateBy(rx, ry, rz);
		if (isLinked) {
			m.isLinked = true;
			m.linkedModel = linkedModel;
			m.linkedTrans = linkedTrans;
		}
		m.setBlendMode(blendMode);
		if (doGlow || doBlur) {
			m.setFilterDirect(filterArray);
		}
		//var p = main.attachMovie("part", "part"+_ids, _ids) 
		var p = m.properties;
		_total++;
		_particulas[_ids] = m;
		p._id = _ids;
		_ids++;
		//p._x = 300
		//p._y = 300
		//p.centroX = 300
		//p.centroY = 300
		p.velX = Math.random()*(maxX-minX)+minX;
		p.velZ = Math.random()*(maxZ-minZ)+minZ;
		if (random(2) == 0) {
			p.dirX = -1;
		} else {
			p.dirX = 1;
		}
		if (random(2) == 0) {
			p.dirZ = -1;
		} else {
			p.dirZ = 1;
		}
		p.velY = Math.random()*(maxY-minY)+minY;
		p.engine = this;
		p.gravedad = 0;
		p.life = Math.random()*(maxLife-minLife)+minLife;
		p.age = 0;
		var yo = this;
		m.onTicker = function() {
			var coo = m.coords[0];
			coo.x += (p.velX*p.dirX);
			coo.velX *= yo.acelX;
			coo.x = ((coo.x)*yo.magnetoX);
			coo.z += (p.velZ*p.dirZ);
			coo.velZ *= yo.acelZ;
			coo.z = ((coo.z)*yo.magnetoZ);
			p.gravedad += yo._grav;
			coo.y += (p.velY)*-1;
			coo.y += p.gravedad;
			p.velY += yo.acelY;
			p.age++;
			coo.update();
			if (p.age>=p.life) {
				yo.death(p._id);
				//this.onEnterFrame = null
				//removeMovieClip(this);
				yo.main.removeModel(m);
				//trace("a");
			}
		};
		m.doOnTicker = true;
	}
	function death(id) {
		delete _particulas[id];
		_total--;
	}
}
