﻿class easyMoveObject {
	var object;
	var RXdo = true;
	var RXposib = 600*Math.PI/180;
	var RXmod = 300*Math.PI/180;
	var RYdo = true;
	var RYposib = 600*Math.PI/180;
	var RYmod = 300*Math.PI/180;
	var RZdo = true;
	var RZposib = 600*Math.PI/180;
	var RZmod = 300*Math.PI/180;
	var newRX = 0
	var newRY = 0
	var newRZ = 0
	var TXdo = true;
	var TXposib = 3;
	var TXmod = 1.5;
	var TYdo = true;
	var TYposib = 3;
	var TYmod = 1.5;
	var TZdo = true;
	var TZposib = 300;
	var TZmod = 0;
	var newTX = 0
	var newTY = 0
	var newTZ = 0
	var velocity = 0.1
	var _id;
	var _idNUM;
	var doOnAudioModo2 = true
	var doOnEveryFrame = false
	var doOnAudioModo1 = false
	function easyMoveObject(o) {
		object = o;
		newPositions()
	}
	function newPositions () {
		newRX = Math.random()*RXposib-RXmod
		newRY = Math.random()*RYposib-RYmod
		newRZ = Math.random()*RZposib-RZmod
		newTX = Math.random()*TXposib-TXmod
		newTY = Math.random()*TYposib-TYmod
		newTZ = Math.random()*TZposib-TZmod
	}
	function render() {
		var cr = object.getRotation()
		var cc = object.getCoordinates()
		var nrx = cr.x
		var nry = cr.y
		var nrz = cr.z
		var nx = cc.x
		var ny = cc.y
		var nz = cc.z
		//trace(nrx+":"+nry+":"+nrz + "<---");
		if (RXdo) {
			nrx+=(newRX-nrx)*velocity
		}
		if (RYdo) {
			nry+=(newRY-nry)*velocity
		}
		if (RZdo) {
			nrz+=(newRZ-nrz)*velocity
		}
		if (TXdo) {
			nx+=(newTX-nx)*velocity
		}
		if (TYdo) {
			ny+=(newTY-ny)*velocity
		}
		if (TZdo) {
			nz+=(newTZ-nz)*velocity
		}
		//trace(nrx+":"+nry+":"+nrz);

		object.setRotation(nrx,nry,nrz)
		//trace(nrx+":"+nry+":"+nrz);
		object.setCoordinates(nx,ny,nz)
		var e = false
		if (_global.FLAXUS_ONMODOAUDIO2==true && doOnAudioModo2) {
			e=true
		}
		if (_global.FLAXUS_ONMODOAUDIO1==true && doOnAudioModo1) {
			e=true
		}
		if (doOnEveryFrame) {
			e=true
		}
		if (e) {
			newPositions()
		}

	}
	function enableRX(posib, mod) {
		RXdo = true;
		RXposib = posib;
		RXmod = mod;
	}
	function enableRY(posib, mod) {
		RYdo = true;
		RYposib = posib;
		RYmod = mod;
	}
	function enableRZ(posib, mod) {
		RZdo = true;
		RZposib = posib;
		RZmod = mod;
	}
	function disableRX () {
		RXdo = false
	}
	function disableRY () {
		RYdo = false
	}
	function disableRZ () {
		RZdo = false
	}
	function enableTX(posib, mod) {
		TXdo = true;
		TXposib = posib;
		TXmod = mod;
	}
	function enableTY(posib, mod) {
		TYdo = true;
		TYposib = posib;
		TYmod = mod;
	}
	function enableTZ(posib, mod) {
		TZdo = true;
		TZposib = posib;
		TZmod = mod;
	}
	function disableTX () {
		TXdo = false
	}
	function disableTY () {
		TYdo = false
	}
	function disableTZ () {
		TZdo = false
	}
}
