﻿import flash.display.BitmapData;
import flash.geom.Rectangle;
import flash.geom.Matrix;
import flash.geom.ColorTransform;
import flash.filters.ConvolutionFilter;
class script.BoxCodeLibrary {
	var _actions:Array;
	var _all_objects:Object;
	var _funciones:Object;
	var _variables:Object;
	var _currentFN:Object;
	var _gradients:Object;
	var _filters:Object;
	var _engine:Object;
	var _modelsCreated:Object;
	var _modelsID:Number = 0;
	var _modelsID_libres:Object;
	var _pluginCreated:Object;
	var _pluginID:Number = 0;
	var _pluginID_libres:Object;
	var _gradCreated:Object;
	var _gradID:Number = 0;
	var _gradID_libres:Object;
	var _filterCreated:Object;
	var _filterID:Number = 0;
	var _filterID_libres:Object;
	var _everyframe = null;
	var _activeModel = null;
	var _activeObject = null;
	var _activePlugin = null;
	var _activeGrad = null;
	var _activeFilter = null;
	var _currentCoordinates = null;
	var _currentRotation = null;
	var __rotationX = null;
	var __rotationY = null;
	var __rotationZ = null;
	var __positionX = null;
	var __positionY = null;
	var __positionZ = null;
	var __PI = 3.14159265358979;
	var _currentColor = 0xEEEEEE;
	var _currentColorR = 255;
	var _currentColorG = 255;
	var _currentColorB = 255;
	var _currentColorModelR = 235;
	var _currentColorModelG = 235;
	var _currentColorModelB = 235;
	var _histModel:Array;
	var _histPlugin:Array;
	var _histGrad:Array;
	var _histObject:Array;
	var _histFilter:Array;
	//
	var _server:NetConnection;
	var _shared:SharedObject;
	var _serverConected = false;
	var _user = "";
	var _userMODO = 0;
	var _userNAME = "";
	function BoxCodeLibrary(en) {
		_engine = en;
		_actions = new Array();
		_funciones = new Object();
		_variables = new Object();
		_gradients = {};
		_filters = {};
		_all_objects = {};
		_currentFN = null;
		_modelsCreated = {};
		_modelsID_libres = {};
		_pluginCreated = {};
		_pluginID_libres = {};
		_gradCreated = {};
		_gradID_libres = {};
		_filterCreated = {};
		_filterID_libres = {};
		_histModel = [];
		_histPlugin = [];
		_histGrad = [];
		_histObject = [];
		_histFilter = [];
		_global.FLAXUS_OUTPUT = "";
	}
	function pushModel(p) {
		_histModel.push(_activeModel);
		_activeModel = p[0];
		_activeObject = p[0];
	}
	function popModel() {
		_activeModel = _histModel.pop();
		_activeObject = _activeModel;
	}
	function pushObject(p) {
		_histObject.push(_activeObject);
		_activeObject = p[0];
	}
	function popObject() {
		_activeObject = _histObject.pop();
	}
	function pushPlugin(p) {
		_histPlugin.push(_activePlugin);
		_activePlugin = p[0];
		_activeObject = p[0];
	}
	function popPlugin() {
		_activePlugin = _histPlugin.pop();
		_activeObject = _activePlugin;
	}
	function pushGrad(p) {
		_histGrad.push(_activeGrad);
		_activeGrad = p[0];
		_activeObject = p[0];
	}
	function popGrad() {
		_activeGrad = _histGrad.pop();
		_activeObject = _activeGrad;
	}
	function pushFilter(p) {
		_histFilter.push(_activeFilter);
		_activeFilter = p[0];
		_activeObject = p[0];
	}
	function popFilter() {
		_activeFilter = _histFilter.pop();
		_activeObject = _activeFilter;
	}
	function render() {
		//para renderear las funciones de timer
		/*for (var i in _funciones) {
		runFN([i]);
		}*/
		if (_everyframe != null) {
			runFN([_everyframe]);
		}
	}
	function run() {
		for (var i = 0; i<_actions.length; i++) {
			//this[_actions[i].acc](_actions[i].mod)
			runInt(_actions[i]);
		}
	}
	function runInt(ac) {
		if (ac.acc == "define") {
			var nom;
			if (ac.mod[0].type == "BoxCode") {
				nom = runInt(ac.mod[0]);
			} else {
				nom = ac.mod[0];
			}
			var nacc = [];
			for (var i = 1; i<ac.mod.length; i++) {
				nacc[i-1] = ac.mod[i];
			}
			return this[ac.acc]([nom, nacc]);
		} else if (ac.acc == "onAudioModo2") {
			var nacc = [];
			for (var i = 0; i<ac.mod.length; i++) {
				nacc[i] = ac.mod[i];
			}
			return this[ac.acc](["_onAudioModo2", nacc]);
		} else if (ac.acc == "onAudioModo1") {
			var nacc = [];
			for (var i = 0; i<ac.mod.length; i++) {
				nacc[i] = ac.mod[i];
			}
			return this[ac.acc](["_onAudioModo1", nacc]);
		} else if (ac.acc == "add_to_every_frame" || ac.acc == "add_to_onAudioModo2" || ac.acc == "add_to_onAudioModo1") {
			var nacc = [];
			for (var i = 0; i<ac.mod.length; i++) {
				nacc[i] = ac.mod[i];
			}
			return this[ac.acc]([nacc]);
		} else if (ac.acc == "add_to_definition") {
			var nacc = [];
			var nom;
			if (ac.mod[0].type == "BoxCode") {
				nom = runInt(ac.mod[0]);
			} else {
				nom = ac.mod[0];
			}
			for (var i = 1; i<ac.mod.length; i++) {
				nacc[i-1] = ac.mod[i];
			}
			return this[ac.acc]([nom, nacc]);
		} else if (ac.acc == "condition") {
			var nom;
			var nacc = [];
			for (var i = 0; i<ac.mod.length; i++) {
				nacc[i] = ac.mod[i];
			}
			return this[ac.acc](nacc);
		} else {
			var calc = new Array(ac.mod.length);
			for (var i = 0; i<ac.mod.length; i++) {
				if (ac.mod[i].type == "BoxCode") {
					calc[i] = runInt(ac.mod[i]);
				} else {
					calc[i] = ac.mod[i];
				}
			}
			return this[ac.acc](calc);
		}
	}
	function every_frame(p) {
		_everyframe = p[0];
	}
	function add_to_every_frame(p) {
		/*for (var i = 0; i<p[0].length; i++) {
		_everyframe.push(p[0][i]);
		}*/
		var fn = _funciones[_everyframe].commands;
		for (var i = 0; i<p[0].length; i++) {
			fn.push(p[0][i]);
		}
	}
	function add_to_onAudioModo2(p) {
		//_funciones[p[0]].commands
		var fn = _funciones["_onAudioModo2"].commands;
		for (var i = 0; i<p[0].length; i++) {
			fn.push(p[0][i]);
		}
	}
	function add_to_onAudioModo1(p) {
		//_funciones[p[0]].commands
		var fn = _funciones["_onAudioModo1"].commands;
		for (var i = 0; i<p[0].length; i++) {
			fn.push(p[0][i]);
		}
	}
	function add_to_definition(p) {
		//_funciones[p[0]].commands
		var fn = _funciones[p[0]].commands;
		for (var i = 0; i<p[1].length; i++) {
			fn.push(p[1][i]);
		}
	}
	function addAction(act, par) {
		var o = new script.Box(act, par);
		_actions.push(o);
	}
	function clearActions() {
		_actions = new Array();
	}
	function addFN(p) {
		if (p[1] != null && p[1] != undefined) {
			_funciones[p[0]] = {};
			_funciones[p[0]].vars = {};
			_funciones[p[0]].commands = p[1];
			if (p[0].charAt(0) != "_") {
				_root.listaFunction.addItemList(p[0]);
			}
		} else {
			if (p[0].charAt(0) != "_") {
				delete _funciones[p[0]];
				delete _funciones[p[0]].vars;
				delete _funciones[p[0]].commands;
				_root.listaFunction.removeItemList(p[0]);
			}
		}
	}
	function deleteDefinition(p) {
		if (p[0].charAt(0) != "_") {
			delete _funciones[p[0]];
			delete _funciones[p[0]].vars;
			delete _funciones[p[0]].commands;
			_root.listaFunction.removeItemList(p[0]);
		}
	}
	function deleteAllDefinition() {
		for (var i in _funciones) {
			deleteDefinition([i]);
		}
	}
	function define(p) {
		addFN(p);
	}
	function use(p) {
		runFN(p);
	}
	function runFN(p) {
		_currentFN = _funciones[p[0]];
		_currentFN.vars = new Object();
		for (var i = 0; i<_funciones[p[0]].commands.length-1; i++) {
			runInt(_funciones[p[0]].commands[i]);
		}
		return runInt(_funciones[p[0]].commands[_funciones[p[0]].commands.length-1]);
	}
	function setVar(p) {
		if (p[2] == "temp") {
			_currentFN.vars[p[0]] = p[1];
		} else {
			_root.listaFunction.addItemList(p[0]);
			_variables[p[0]] = p[1];
		}
	}
	function deleteVar(p) {
		if (p[1] == "temp") {
			delete _currentFN.vars[p[0]];
		} else {
			_root.listaFunction.removeItemList(p[0]);
			delete _variables[p[0]];
		}
	}
	function deleteAllVar() {
		var p = [];
		for (var i in _variables) {
			p.push(i);
		}
		for (var i = 0; i<p.length; i++) {
			deleteVar([p[i]]);
		}
	}
	function getVar(p) {
		if (p[1] == "temp") {
			return _currentFN.vars[p[0]];
		} else {
			return _variables[p[0]];
		}
	}
	function myTrace(p) {
		trace(p[0]);
	}
	function setProp(p) {
		var o = eval(p[0]);
		o[p[1]] = p[2];
	}
	function getProp(p) {
		var o = eval(p[0]);
		return o[p[1]];
	}
	//MATH
	function math(p) {
		//abs
		//coseno
		if (p[0] == "modul") {
			return p[1]%p[2];
		}
		if (p[0] == "sum") {
			return p[1]+p[2];
		}
		if (p[0] == "plusone") {
			return p[1]+1;
		}
		if (p[0] == "minusone") {
			return p[1]-1;
		}
		if (p[0] == "degToRad") {
			return p[1]*__PI/180;
		}
		if (p[0] == "radTodeg") {
			return p[1]*180/__PI;
		}
		if (p[0] == "minus") {
			return p[1]-p[2];
		}
		if (p[0] == "mult") {
			return p[1]*p[2];
		}
		if (p[0] == "div") {
			return p[1]*p[2];
		}
		if (p[0] == "random") {
			return random(p[1]);
		}
		if (p[0] == "rnd") {
			return Math.random();
		}
		if (p[0] == "abs") {
			return Math.abs(p[1]);
		}
		if (p[0] == "acos") {
			return Math.acos(p[1]);
		}
		if (p[0] == "asin") {
			return Math.asin(p[1]);
		}
		if (p[0] == "atan") {
			return Math.atan(p[1]);
		}
		if (p[0] == "atan2") {
			return Math.atan2(p[1], p[2]);
		}
		if (p[0] == "ceil") {
			return Math.ceil(p[1]);
		}
		if (p[0] == "cos") {
			return Math.cos(p[1]);
		}
		if (p[0] == "E") {
			return Math.E;
		}
		if (p[0] == "exp") {
			return Math.exp(p[1]);
		}
		if (p[0] == "floor") {
			return Math.floor(p[1]);
		}
		if (p[0] == "LN10") {
			return Math.LN10;
		}
		if (p[0] == "LN2") {
			return Math.LN2;
		}
		if (p[0] == "log") {
			return Math.log(p[1]);
		}
		if (p[0] == "LOG10E") {
			return Math.LOG10E;
		}
		if (p[0] == "LOG2E") {
			return Math.LOG2E;
		}
		if (p[0] == "max") {
			return Math.max(p[1], p[2]);
		}
		if (p[0] == "min") {
			return Math.min(p[1], p[2]);
		}
		if (p[0] == "PI") {
			return Math.PI;
		}
		if (p[0] == "pow") {
			return Math.pow(p[1], p[2]);
		}
		if (p[0] == "round") {
			return Math.round(p[1]);
		}
		if (p[0] == "sin") {
			return Math.sin(p[1]);
		}
		if (p[0] == "sqrt") {
			return Math.sqrt(p[1]);
		}
		if (p[0] == "sqer1_2") {
			return Math.SQRT1_2;
		}
		if (p[0] == "SQRT2") {
			return Math.SQRT2;
		}
		if (p[0] == "tan") {
			return Math.tan(p[1]);
		}
	}
	function toNumber(p) {
		return Number(p[0]);
	}
	//---BuildBox - w,h,prof
	//---BuildSphere size
	//---BuildCylinder r, h
	////BuildStar size, inset //como la esfera, pero ciertos puntos van hacia adentro
	//---BuildPiramid diametro,h
	//---BuildQuad w,h
	//---BuildTriangle w,h
	//---BuildPoly arrayCoords
	//---BuildCircle diam, inicio, fin
	//---BuildIcon ico, scale
	//---BuildLine arrayCoords
	//---BuildCurve arrayCoords
	//---BuildNode
	//---BuildText
	//BuildForma
	function Build_Cube(p) {
		//BuildCube /Scale Layer texture isTextured/ 
		var layer;
		if (p[1] == null || p[1] == undefined) {
			layer = 0;
		} else {
			layer = p[1];
		}
		var tex;
		if (p[2] == null || p[2] == undefined) {
			tex = "";
		} else {
			tex = p[2];
		}
		var istex;
		if (p[3] == null || p[3] == undefined) {
			istex = 0;
		} else {
			istex = p[3];
		}
		if (p.length == 0) {
			var m = _engine.addModel(_global.MODELO_CUBO(50, 0));
		} else {
			var m = _engine.addModel(_global.MODELO_CUBO(p[0], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m.setColor(200, 200, 200);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_cube_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Box(p) {
		//BuildBox /w h b Layer texture isTextured/
		var layer;
		if (p[3] == null || p[3] == undefined) {
			layer = 0;
		} else {
			layer = p[3];
		}
		var tex;
		if (p[4] == null || p[4] == undefined) {
			tex = "";
		} else {
			tex = p[4];
		}
		var istex;
		if (p[5] == null || p[5] == undefined) {
			istex = 0;
		} else {
			istex = p[5];
		}
		if (p.length == 0) {
			var m = _engine.addModel(_global.MODELO_BOX(50, 30, 20, 0));
		} else {
			var m = _engine.addModel(_global.MODELO_BOX(p[0], p[1], p[2], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_box_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Sphere(p) {
		//BuildSphere /Scale Layer texture isTextured/ 
		var layer;
		if (p[1] == null || p[1] == undefined) {
			layer = 0;
		} else {
			layer = p[1];
		}
		var tex;
		if (p[2] == null || p[2] == undefined) {
			tex = "";
		} else {
			tex = p[2];
		}
		var istex;
		if (p[3] == null || p[3] == undefined) {
			istex = 0;
		} else {
			istex = p[3];
		}
		if (p.length == 0) {
			var m = _engine.addModel(_global.MODELO_SPHERE(50, 0));
		} else {
			var m = _engine.addModel(_global.MODELO_SPHERE(p[0], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_sphere_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Cylinder(p) {
		//BuildCylinder /ratio, h, Layer texture isTextured/ 
		var layer;
		if (p[2] == null || p[2] == undefined) {
			layer = 0;
		} else {
			layer = p[2];
		}
		var tex;
		if (p[3] == null || p[3] == undefined) {
			tex = "";
		} else {
			tex = p[3];
		}
		var istex;
		if (p[4] == null || p[4] == undefined) {
			istex = 0;
		} else {
			istex = p[4];
		}
		if (p.length == 0) {
			var m = _engine.addModel(_global.MODELO_CYLINDER(20, 50, 0));
		} else {
			var m = _engine.addModel(_global.MODELO_CYLINDER(p[0], p[1], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_cylinder_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Pyramid(p) {
		//BuildPyramid /ratio, h, Layer texture isTextured/ 
		var layer;
		if (p[2] == null || p[2] == undefined) {
			layer = 0;
		} else {
			layer = p[2];
		}
		var tex;
		if (p[3] == null || p[3] == undefined) {
			tex = "";
		} else {
			tex = p[3];
		}
		var istex;
		if (p[4] == null || p[4] == undefined) {
			istex = 0;
		} else {
			istex = p[4];
		}
		if (p.length == 0) {
			var m = _engine.addModel(_global.MODELO_PYRAMID(20, 50, 0));
		} else {
			var m = _engine.addModel(_global.MODELO_PYRAMID(p[0], p[1], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_pyramid_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Quad(p) {
		//BuildQuad /w, h, Layer texture isTextured/ 
		var layer;
		if (p[2] == null || p[2] == undefined) {
			layer = 0;
		} else {
			layer = p[2];
		}
		var tex;
		if (p[3] == null || p[3] == undefined) {
			tex = "";
		} else {
			tex = p[3];
		}
		var istex;
		if (p[4] == null || p[4] == undefined) {
			istex = 0;
		} else {
			istex = p[4];
		}
		if (p.length == 0) {
			var m = _engine.addModel(_global.MODELO_QUAD(50, 50, 0));
		} else {
			var m = _engine.addModel(_global.MODELO_QUAD(p[0], p[1], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_quad_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Triangle(p) {
		//BuildTriangle /w, h, Layer texture isTextured/ 
		var layer;
		if (p[2] == null || p[2] == undefined) {
			layer = 0;
		} else {
			layer = p[2];
		}
		var tex;
		if (p[3] == null || p[3] == undefined) {
			tex = "";
		} else {
			tex = p[3];
		}
		var istex;
		if (p[4] == null || p[4] == undefined) {
			istex = 0;
		} else {
			istex = p[4];
		}
		if (p.length == 0) {
			var m = _engine.addModel(_global.MODELO_TRIANGLE(50, 50, 0));
		} else {
			var m = _engine.addModel(_global.MODELO_TRIANGLE(p[0], p[1], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_triangle_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Poly(p) {
		//BuildPoly /arrayDePuntos Layer texture isTextured/ 
		var layer;
		if (p[1] == null || p[1] == undefined) {
			layer = 0;
		} else {
			layer = p[1];
		}
		var tex;
		if (p[2] == null || p[2] == undefined) {
			tex = "";
		} else {
			tex = p[2];
		}
		var istex;
		if (p[3] == null || p[3] == undefined) {
			istex = 0;
		} else {
			istex = p[3];
		}
		if (p.length>0) {
			var m = _engine.addModel(_global.MODELO_POLY(p[0], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_poly_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Circle(p) {
		//BuildCircle /rext rini inic fin Layer texture isTextured/
		//una curva total tiene el ini en 0 y el fin en 72, hace cortes cada 5 grados
		var layer;
		if (p[4] == null || p[4] == undefined) {
			layer = 0;
		} else {
			layer = p[4];
		}
		var tex;
		if (p[5] == null || p[5] == undefined) {
			tex = "";
		} else {
			tex = p[5];
		}
		var istex;
		if (p[6] == null || p[6] == undefined) {
			istex = 0;
		} else {
			istex = p[6];
		}
		if (p.length == 0) {
			var m = _engine.addModel(_global.MODELO_CIRCULO(100, 40, 10, 60, 0));
		} else {
			var m = _engine.addModel(_global.MODELO_CIRCULO(p[0], p[1], p[2], p[3], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_circle_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Icon(p) {
		//BuildCylinder /icon, scale, Layer texture isTextured/ 
		var layer;
		if (p[2] == null || p[2] == undefined) {
			layer = 0;
		} else {
			layer = p[2];
		}
		var tex;
		if (p[3] == null || p[3] == undefined) {
			tex = "";
		} else {
			tex = p[3];
		}
		var istex;
		if (p[4] == null || p[4] == undefined) {
			istex = 0;
		} else {
			istex = p[4];
		}
		if (p.length == 0) {
			var m = _engine.addModel(_global.MODELO_ICONO("icon1", 1, 0));
		} else if (p.length == 1) {
			var m = _engine.addModel(_global.MODELO_ICONO(p[0], 1, 0));
		} else {
			var m = _engine.addModel(_global.MODELO_ICONO(p[0], p[1], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_icon"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Line(p) {
		//BuildLine /arrayDePuntos grosor color alpha Layer texture isTextured/ 
		var layer;
		if (p[4] == null || p[4] == undefined) {
			layer = 0;
		} else {
			layer = p[4];
		}
		var tex;
		if (p[5] == null || p[5] == undefined) {
			tex = "";
		} else {
			tex = p[5];
		}
		var istex;
		if (p[6] == null || p[6] == undefined) {
			istex = 0;
		} else {
			istex = p[6];
		}
		if (p.length == 1) {
			var m = _engine.addModel(_global.MODELO_LINE(p[0], 1, 0xFFFFFF, 100, layer, tex, istex));
		} else if (p.length>0) {
			var m = _engine.addModel(_global.MODELO_LINE(p[0], p[1], p[2], p[3], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		//m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_line_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Curve(p) {
		//BuildLine /arrayDePuntos grosor color alpha Layer texture isTextured/ 
		var layer;
		if (p[4] == null || p[4] == undefined) {
			layer = 0;
		} else {
			layer = p[4];
		}
		var tex;
		if (p[5] == null || p[5] == undefined) {
			tex = "";
		} else {
			tex = p[5];
		}
		var istex;
		if (p[6] == null || p[6] == undefined) {
			istex = 0;
		} else {
			istex = p[6];
		}
		if (p.length == 1) {
			var m = _engine.addModel(_global.MODELO_CURVE(p[0], 1, 0xFFFFFF, 100, layer, tex, istex));
		} else if (p.length>0) {
			var m = _engine.addModel(_global.MODELO_CURVE(p[0], p[1], p[2], p[3], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		//m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_curve_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Node(p) {
		//BuildNode
		var layer;
		if (p[0] == null || p[0] == undefined) {
			layer = 0;
		} else {
			layer = p[0];
		}
		var m = _engine.addModel(_global.MODELO_NODE(layer));
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		//m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_node_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	//1, "el texto que quiera", 0xFF0000, 270, 50,"left")
	function Build_Text(p) {
		//BuildText /font texto color width size align Layer texture isTextured/ 
		var layer;
		if (p[6] == null || p[6] == undefined) {
			layer = 0;
		} else {
			layer = p[6];
		}
		var tex;
		if (p[7] == null || p[7] == undefined) {
			tex = "";
		} else {
			tex = p[7];
		}
		var istex;
		if (p[8] == null || p[8] == undefined) {
			istex = 0;
		} else {
			istex = p[8];
		}
		if (p.length == 2) {
			var m = _engine.addModel(_global.MODELO_TEXT(p[0], p[1], 0xFFFFFF, 270, 1, "left", layer, tex, istex));
		} else if (p.length>0) {
			var m = _engine.addModel(_global.MODELO_TEXT(p[0], p[1], p[2], p[3], p[4], p[5], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		//m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_text_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function Build_Forma(p) {
		//BuildForma /tt, mx, my, mz Layer texture isTextured/ 
		var layer;
		if (p[4] == null || p[4] == undefined) {
			layer = 0;
		} else {
			layer = p[4];
		}
		var tex;
		if (p[5] == null || p[5] == undefined) {
			tex = "";
		} else {
			tex = p[5];
		}
		var istex;
		if (p[6] == null || p[6] == undefined) {
			istex = 0;
		} else {
			istex = p[6];
		}
		if (p.length == 0) {
			var m = _engine.addModel(_global.MODELO_FORMA(int(random(15)+5), 200, 200, 200, layer, tex, istex));
		} else if (p.length>0) {
			var m = _engine.addModel(_global.MODELO_FORMA(p[0], p[1], p[2], p[3], layer, tex, istex));
		}
		m.setCoordinates(0, 0, 0);
		m.rotateBy(0, 0, 0);
		m.setColor(_currentColorModelR, _currentColorModelG, _currentColorModelB);
		//m5.setAlpha(20)
		m.linkedModel = _global.FLAXUS_EJE;
		m.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		m.isLinked = true;
		m.properties._flaxusID = _asignIDModel();
		m.properties._flaxusIDCOMP = "m_forma_"+m.properties._flaxusID;
		_modelsCreated[m.properties._flaxusIDCOMP] = m;
		_all_objects[m.properties._flaxusIDCOMP] = m;
		_activeObject = m;
		_activeModel = m;
		_root.listaModels.addItemList(m.properties._flaxusIDCOMP);
	}
	function doExtrudeAnim(p) {
		//mo, pasos, ext(vector x y z), extmin(vector x y z), limitesinf(vector x y z), limitessup(vector x y z), mult)
		if (p[0] == "ACTIVE_MODEL") {
			var o = _activeModel;
		} else if (typeof (p[0]) == "string") {
			var o = _modelsCreated[p[0]];
		} else {
			var o = p[0];
		}
		o.properties.toExtrude = new Array();
		o.properties.toExtrudeSX = new Array();
		o.properties.toExtrudeSY = new Array();
		o.properties.toExtrudeSZ = new Array();
		o.properties.toExtrudeCOUNTER = 0;
		var pasos = random(100)+100;
		if (p[1] != null && p[1] != undefined) {
			pasos = p[1];
		}
		o.properties.toExtrudeLIFE = pasos;
		var limitessup = [random(200), random(200), random(200)];
		var limitesinf = [-(random(200)), -(random(200)), -(random(200))];
		if (p[4] != null && p[4] != undefined) {
			limitesinf = p[4];
		}
		if (p[5] != null && p[5] != undefined) {
			limitessup = p[5];
		}
		var ext = [random(800), random(800), random(800)];
		var extmin = [random(100), random(100), random(100)];
		var mult = [random(3)-1, random(3)-1, random(3)-1];
		if (p[2] != null && p[2] != undefined) {
			ext = p[2];
		}
		if (p[3] != null && p[3] != undefined) {
			extmin = p[3];
		}
		if (p[6] != null && p[6] != undefined) {
			mult = p[6];
		}
		for (var i in o.coords) {
			var e = true;
			if (o.coords[i].x<limitesinf[0] || o.coords[i].x>limitessup[0]) {
				e = false;
			}
			if (o.coords[i].y<limitesinf[1] || o.coords[i].y>limitessup[1]) {
				e = false;
			}
			if (o.coords[i].z<limitesinf[2] || o.coords[i].z>limitessup[2]) {
				e = false;
			}
			if (e == true) {
				o.properties.toExtrude.push(o.coords[i]);
				o.properties.toExtrudeSX.push((random(ext[0])*mult[0]+extmin[0])/pasos);
				o.properties.toExtrudeSY.push((random(ext[1])*mult[1]+extmin[1])/pasos);
				o.properties.toExtrudeSZ.push((random(ext[2])*mult[2]+extmin[2])/pasos);
			}
		}
		o.onTicker = function() {
			var tp = this.properties;
			for (var i = 0; i<tp.toExtrude.length; i++) {
				var cc = tp.toExtrude[i];
				cc.x += tp.toExtrudeSX[i];
				cc.y += tp.toExtrudeSY[i];
				cc.z += tp.toExtrudeSZ[i];
			}
			tp.toExtrudeCOUNTER++;
			if (tp.toExtrudeCOUNTER>=tp.toExtrudeLIFE) {
				this.onTicker = null;
				this.doOnTicker = false;
			}
		};
		o.doOnTicker = true;
	}
	function doExtrude(p) {
		//mo, ext(vector x y z), extmin(vector x y z), limitesinf(vector x y z), limitessup(vector x y z), mult)
		if (p[0] == "ACTIVE_MODEL") {
			var o = _activeModel;
		} else if (typeof (p[0]) == "string") {
			var o = _modelsCreated[p[0]];
		} else {
			var o = p[0];
		}
		var limitessup = [random(200), random(200), random(200)];
		var limitesinf = [-(random(200)), -(random(200)), -(random(200))];
		if (p[3] != null && p[3] != undefined) {
			limitesinf = p[3];
		}
		if (p[4] != null && p[4] != undefined) {
			limitessup = p[4];
		}
		var ext = [random(100), random(100), random(100)];
		var extmin = [random(100), random(100), random(100)];
		var mult = [random(3)-1, random(3)-1, random(3)-1];
		if (p[1] != null && p[1] != undefined) {
			ext = p[1];
		}
		if (p[2] != null && p[2] != undefined) {
			extmin = p[2];
		}
		if (p[5] != null && p[5] != undefined) {
			mult = p[5];
		}
		for (var i in o.coords) {
			var e = true;
			if (o.coords[i].x<limitesinf[0] || o.coords[i].x>limitessup[0]) {
				e = false;
			}
			if (o.coords[i].y<limitesinf[1] || o.coords[i].y>limitessup[1]) {
				e = false;
			}
			if (o.coords[i].z<limitesinf[2] || o.coords[i].z>limitessup[2]) {
				e = false;
			}
			if (e == true) {
				o.coords[i].x += random(ext[0])*mult[0]+extmin[0];
				o.coords[i].y += random(ext[1])*mult[1]+extmin[1];
				o.coords[i].z += random(ext[2])*mult[2]+extmin[2];
			}
		}
	}
	function getModel(p) {
		_activeModel = _modelsCreated[p[0]];
	}
	function getRotation() {
		var cr = _activeModel.getRotation();
		__rotationX = cr.x;
		__rotationY = cr.y;
		__rotationZ = cr.z;
		//__rotationX = _activeModel.linkedTrans.rx
		//__rotationY = _activeModel.linkedTrans.ry
		//__rotationZ = _activeModel.linkedTrans.rz
	}
	function getPosition() {
		/*var cr = _activeModel.getCoordinates()
		__positionX = cr.x
		__positionY = cr.y
		__positionZ = cr.z*/
		__positionX = _activeModel.linkedTrans.x;
		__positionY = _activeModel.linkedTrans.y;
		__positionZ = _activeModel.linkedTrans.z;
	}
	function setRotation(p) {
		_activeModel.setRotation(Number(p[0]), Number(p[1]), Number(p[2]));
		/*_activeModel.linkedTrans.rx = p[0]
		_activeModel.linkedTrans.ry = p[1]
		_activeModel.linkedTrans.rz = p[2]*/
		getRotation();
	}
	function setPosition(p) {
		//_activeModel.setCoordinates(p[0],p[1],p[2])
		_activeModel.linkedTrans.x = Number(p[0]);
		_activeModel.linkedTrans.y = Number(p[1]);
		_activeModel.linkedTrans.z = Number(p[2]);
		getPosition();
	}
	function setBlendMode(p) {
		_activeModel.setBlendMode(p[0]);
	}
	function getRotationX() {
		return __rotationX;
	}
	function getRotationY() {
		return __rotationY;
	}
	function getRotationZ() {
		return __rotationZ;
	}
	function getPositionX() {
		return __positionX;
	}
	function getPositionY() {
		return __positionY;
	}
	function getPositionZ() {
		return __positionZ;
	}
	/*function clearModels() {
	//TODO; QUE BORRE LOS IDS
	//for (var i in _engine.models) {
	//_engine.removeModel(_engine.models[i]);
	//}
	}*/
	function deleteModel(p) {
		if (p[0] == "ACTIVE_MODEL") {
			var o = _activeModel;
		} else if (typeof (p[0]) == "string") {
			var o = _modelsCreated[p[0]];
		} else {
			var o = p[0];
		}
		delete _modelsCreated[o.properties._flaxusIDCOMP];
		delete _all_objects[o.properties._flaxusIDCOMP];
		_modelsID_libres[o.properties._flaxusID] = true;
		_engine.removeModel(o);
		_root.listaModels.removeItemList(o.properties._flaxusIDCOMP);
	}
	function deleteAllModels() {
		var lista = [];
		for (var i in _modelsCreated) {
			lista.push(i);
		}
		for (var i = 0; i<lista.length; i++) {
			deleteModel([lista[i]]);
		}
	}
	function deletePlugin(p) {
		if (p[0] == "ACTIVE_PLUGIN") {
			var o = _activePlugin;
		} else if (typeof (p[0]) == "string") {
			var o = _pluginCreated[p[0]];
		} else {
			var o = p[0];
		}
		//_engine.removeModel(o);
		_pluginID_libres[o._idNUM] = true;
		delete _pluginCreated[o._id];
		delete _all_objects[o._id];
		for (var i = 0; i<_global.FLAXUS_TIMER.length; i++) {
			if (_global.FLAXUS_TIMER[i]._id == o._id) {
				_global.FLAXUS_TIMER.splice(i, 1);
			}
		}
		_root.listaPlugin.removeItemList(o._id);
	}
	function deleteAllPlugin() {
		var lista = [];
		for (var i in _pluginCreated) {
			lista.push(i);
		}
		for (var i = 0; i<lista.length; i++) {
			deletePlugin([lista[i]]);
		}
	}
	function deleteGrad(p) {
		if (p[0] == "ACTIVE_GRADIENT") {
			var o = _activeGrad;
		} else if (typeof (p[0]) == "string") {
			var o = _gradCreated[p[0]];
		} else {
			var o = p[0];
		}
		//_engine.removeModel(o);
		_gradID_libres[o._idNUM] = true;
		delete _gradCreated[o._id];
		delete _all_objects[o._id];
		_root.listaPlugin.removeItemList(o._id);
		removeMovieClip(_global.FLAXUS_GRADIENTSCONT[o._id]);
		_global.FLAXUS_GRADIENTSCONT[o._id].removeMovieClip();
	}
	function deleteAllGrad() {
		var lista = [];
		for (var i in _gradCreated) {
			lista.push(i);
		}
		for (var i = 0; i<lista.length; i++) {
			deleteGrad([lista[i]]);
		}
	}
	function deleteFilter(p) {
		if (p[0] == "ACTIVE_FILTER") {
			var o = _activeFilter;
		} else if (typeof (p[0]) == "string") {
			var o = _filterCreated[p[0]];
		} else {
			var o = p[0];
		}
		//_engine.removeModel(o);
		_filterID_libres[o._idNUM] = true;
		delete _filterCreated[o._id];
		delete _all_objects[o._id];
		_root.listaPlugin.removeItemList(o._id);
		//removeMovieClip(_global.FLAXUS_GRADIENTSCONT[o._id]);
		//_global.FLAXUS_GRADIENTSCONT[o._id].removeMovieClip();
	}
	function deleteAllFilter() {
		var lista = [];
		for (var i in _filterCreated) {
			lista.push(i);
		}
		for (var i = 0; i<lista.length; i++) {
			deleteFilter([lista[i]]);
		}
	}
	function deleteAll() {
		deleteAllModels();
		deleteAllPlugin();
		deleteAllGrad();
		deleteAllFilter();
	}
	function condition(p) {
		var e = false;
		if (p[0] == "<") {
			if (p[1]<p[2]) {
				runInt(p[3].acc);
				for (var i = 0; i<p[3].mod.length; i++) {
					runInt(p[3].mod[i]);
				}
				e = true;
			} else {
				runInt(p[4].acc);
				for (var i = 0; i<p[4].mod.length; i++) {
					runInt(p[4].mod[i]);
				}
				e = false;
			}
		} else if (p[0] == ">") {
			if (p[1]>p[2]) {
				runInt(p[3].acc);
				for (var i = 0; i<p[3].mod.length; i++) {
					runInt(p[3].mod[i]);
				}
				e = true;
			} else {
				runInt(p[4].acc);
				for (var i = 0; i<p[4].mod.length; i++) {
					runInt(p[4].mod[i]);
				}
				e = false;
			}
		} else if (p[0] == "==") {
			if (p[1] == p[2]) {
				runInt(p[3].acc);
				for (var i = 0; i<p[3].mod.length; i++) {
					runInt(p[3].mod[i]);
				}
				e = true;
			} else {
				runInt(p[4].acc);
				for (var i = 0; i<p[4].mod.length; i++) {
					runInt(p[4].mod[i]);
				}
				e = false;
			}
		} else if (p[0] == "<=") {
			if (p[1]<=p[2]) {
				runInt(p[3].acc);
				for (var i = 0; i<p[3].mod.length; i++) {
					runInt(p[3].mod[i]);
				}
				e = true;
			} else {
				runInt(p[4].acc);
				for (var i = 0; i<p[4].mod.length; i++) {
					runInt(p[4].mod[i]);
				}
				e = false;
			}
		} else if (p[0] == ">=") {
			if (p[1]>=p[2]) {
				runInt(p[3].acc);
				for (var i = 0; i<p[3].mod.length; i++) {
					runInt(p[3].mod[i]);
				}
				e = true;
			} else {
				runInt(p[4].acc);
				for (var i = 0; i<p[4].mod.length; i++) {
					runInt(p[4].mod[i]);
				}
				e = false;
			}
		} else if (p[0] == "!=") {
			if (p[1] != p[2]) {
				runInt(p[3].acc);
				for (var i = 0; i<p[3].mod.length; i++) {
					runInt(p[3].mod[i]);
				}
				e = true;
			} else {
				runInt(p[4].acc);
				for (var i = 0; i<p[4].mod.length; i++) {
					runInt(p[4].mod[i]);
				}
				e = false;
			}
		}
		return e;
	}
	function onAudioModo2(p) {
		addFN(p);
	}
	function onAudioModo1(p) {
		addFN(p);
	}
	function Create_Move(p) {
		Create_Mov(p);
	}
	function Create_Mov(p) {
		var mm;
		if (p[1] == "global") {
			mm = _global.FLAXUS_EJE;
		} else {
			mm = _modelsCreated[p[1]];
		}
		if (p[0] == "easy") {
			var EasyMov = new easyMoveObject(mm);
			var idNUM = _asignIDPlugin();
			var id = "mov_easy_"+idNUM;
			EasyMov._id = id;
			EasyMov._idNUM = idNUM;
			_pluginCreated[id] = EasyMov;
			trace(id);
			_all_objects[id] = EasyMov;
			_activeObject = EasyMov;
			_activePlugin = EasyMov;
			_global.FLAXUS_TIMER.push(EasyMov);
		} else if (p[0] == "noise") {
			var NoiseMov = new noiseMoveObject(mm);
			var idNUM = _asignIDPlugin();
			var id = "mov_noise_"+idNUM;
			NoiseMov._idNUM = idNUM;
			NoiseMov._id = id;
			_pluginCreated[id] = NoiseMov;
			_all_objects[id] = NoiseMov;
			trace(id);
			_activeObject = NoiseMov;
			_activePlugin = NoiseMov;
			_global.FLAXUS_TIMER.push(NoiseMov);
		}
		_root.listaPlugin.addItemList(id);
		//var EasyMov = new easyMoveObject(_root.EJE)          
	}
	function Create_ParticleSys(p) {
		//p[0] = icon
		//p[1] = 0/1 es linkeado
		//p[2] = a quien linkea
		var mm;
		if (p[2] == "global" || p.length<=1 || p[1] == 0) {
			mm = _global.FLAXUS_EJE;
		} else {
			mm = _modelsCreated[p[1]];
		}
		var link;
		if (p[1] == 1 || p.length<=1) {
			link = true;
		} else {
			link = false;
		}
		var PartSys = new ParticleSystem(_engine);
		if (link == true) {
			PartSys.isLinked = true;
			PartSys.linkedModel = mm;
			PartSys.linkedTrans = {x:0, y:0, z:0, rx:0, ry:0, rz:0};
		} else {
			PartSys.isLinked = false;
		}
		if (typeof (p[0]) != "string") {
			PartSys._icon = "icon2";
		} else {
			PartSys._icon = p[0];
		}
		var idNUM = _asignIDPlugin();
		var id = "part_"+idNUM;
		PartSys._id = id;
		PartSys._idNUM = idNUM;
		_pluginCreated[id] = PartSys;
		_all_objects[id] = PartSys;
		_activeObject = PartSys;
		_activePlugin = PartSys;
		_global.FLAXUS_TIMER.push(PartSys);
		_root.listaPlugin.addItemList(id);
		/*var PartSys = new ParticleSystem(sup.en);
		PartSys.z = 20;
		PartSys.isLinked = true;
		PartSys.linkedModel = _root.EJE;
		PartSys.linkedTrans = {x:0, y:0, z:0, rx:(0*Math.PI/180), ry:0, rz:0};
		PartSys.blendMode = "overlay";
		//PartSys.setBlur(1, 5, 1);
		this.onEnterFrame = function() {
		PartSys.run();
		};*/
	}
	function Create_Mixer(p) {
		var mix = new Mixer(this);
		var idNUM = _asignIDPlugin();
		var id = "mixer_"+idNUM;
		mix._id = id;
		mix._idNUM = idNUM;
		_pluginCreated[id] = mix;
		_all_objects[id] = mix;
		_activeObject = mix;
		_activePlugin = mix;
		_global.FLAXUS_TIMER.push(mix);
		_root.listaPlugin.addItemList(id);
	}
	function Create_Signal(p) {
		var sig = new Signal(this, p[0]);
		var idNUM = _asignIDPlugin();
		var id = "signal_"+idNUM;
		sig._id = id;
		sig._idNUM = idNUM;
		_pluginCreated[id] = sig;
		_all_objects[id] = sig;
		_activeObject = sig;
		_activePlugin = sig;
		_global.FLAXUS_TIMER.push(sig);
		_root.listaPlugin.addItemList(id);
	}
	function Create_Filter(p) {
		var fil = new FilterSys(p);
		var idNUM = _asignIDPlugin();
		var id = "filter_"+p[0]+"_"+idNUM;
		fil._id = id;
		fil._idNUM = idNUM;
		_filterCreated[id] = fil;
		_all_objects[id] = fil;
		_activeObject = fil;
		_activeFilter = fil;
		//_global.FLAXUS_TIMER.push(sig);
		_root.listaPlugin.addItemList(id);
	}
	function setFilter(p) {
		var fils = [];
		for (var i = 0; i<p.length; i++) {
			if (p[i] == "ACTIVE_FILTER") {
				fils[i] = _activeFilter.fil;
			} else if (typeof (p[i]) == "string") {
				fils[i] = _filterCreated[p[i]].fil;
			} else {
				fils[i] = p[i].fil;
			}
		}
		_activeModel.setFilterDirect(fils);
	}
	function setSwitch(p) {
		_activePlugin.setSwitch(p[0], p[1]);
	}
	function doOnAudioModo2(p) {
		_activePlugin.doOnAudioModo2 = p[0];
	}
	function doOnAudioModo1(p) {
		_activePlugin.doOnAudioModo1 = p[0];
	}
	function doOnEveryFrame(p) {
		_activePlugin.doOnEveryFrame = p[0];
	}
	function object(p) {
		//(object unobjeto set x 10)
		if (p[0] == "ACTIVE_OBJECT") {
			var o = _activeObject;
		} else if (p[0] == "ACTIVE_PLUGIN") {
			var o = _activePlugin;
		} else if (p[0] == "ACTIVE_MODEL") {
			var o = _activeModel;
		} else if (p[0] == "ACTIVE_GRADIENT") {
			var o = _activeGrad;
		} else if (p[0] == "ACTIVE_FILTER") {
			var o = _activeFilter;
		} else if (typeof (p[0]) == "string") {
			var o = _all_objects[p[0]];
		} else {
			var o = p[0];
		}
		if (p[1] == "set") {
			o[p[2]] = p[3];
		} else if (p[1] == "get") {
			return o[p[2]];
		} else if (p[1] == "getFN") {
			return o[p[2]](p[3], p[4], p[5], p[6], p[7], p[8], p[9], p[10], p[11], p[12], p[13]);
		} else if (p[1] == "call") {
			o[p[2]](p[3], p[4], p[5], p[6], p[7], p[8], p[9], p[10], p[11], p[12], p[13]);
		} else if (p[1] == "getObject") {
			_activeObject = o;
			return o;
		}
	}
	function AudioPort(p) {
		if (p[0] == "getLevel") {
			return _global.FLAXUS_AUDIO.getLevel();
		}
	}
	function Create_Gradient(p) {
		//color1, color2, color3, fillType, alpha1,alpha2,alpha3,rotacion
		var idNUM = _asignIDGrad();
		var id = "fill_grad_"+idNUM;
		_global.FLAXUS_GRADIENTSCONT.createEmptyMovieClip(id, _global.FLAXUS_GRADIENTSCONT.getNextHighestDepth());
		var mc = _global.FLAXUS_GRADIENTSCONT[id];
		mc._id = id;
		mc._idNUM = idNUM;
		//with (_global.FLAXUS_GRADIENTSCONT[id]) {
		var colors = [Number(p[0]), Number(p[1]), Number(p[2])];
		var fillType = p[3];
		//"linear";
		var alphas = [p[4], p[5], p[6]];
		var ratios = [0, 128, 255];
		var spreadMethod = "pad";
		var interpolationMethod = "RGB";
		var focalPointRatio = 0;
		var matrix = new Matrix();
		matrix.createGradientBox(240, 180, (p[7]+90)*__PI/180, 0, 0);
		mc.beginGradientFill(fillType, colors, alphas, ratios, matrix, spreadMethod, interpolationMethod, focalPointRatio);
		//beginFill(0xFFFFFF,100)
		mc.moveTo(0, 0);
		mc.lineTo(0, 180);
		mc.lineTo(240, 180);
		mc.lineTo(240, 0);
		mc.lineTo(0, 0);
		mc.endFill();
		//}
		_global.FLAXUS_GRADIENTSCONT[id]._visible = false;
		_gradCreated[id] = _global.FLAXUS_GRADIENTSCONT[id];
		_all_objects[id] = _global.FLAXUS_GRADIENTSCONT[id];
		_activeObject = _global.FLAXUS_GRADIENTSCONT[id];
		_activeGrad = _global.FLAXUS_GRADIENTSCONT[id];
		_root.listaPlugin.addItemList(id);
	}
	function Modify_Gradient(p) {
		//object, color1, color2, color3, fillType, alpha1,alpha2,alpha3,rotacion
		if (p[0] == "ACTIVE_GRADIENT") {
			var ob = _activeGrad;
		} else if (typeof (p[0]) == "string") {
			var ob = _gradCreated[p[0]];
		} else {
			var ob = p[0];
		}
		//with (ob) {
		var colors = [p[1], p[2], p[3]];
		var fillType = p[4];
		//"linear";
		var alphas = [p[5], p[6], p[7]];
		var ratios = [0, 128, 255];
		var spreadMethod = "pad";
		var interpolationMethod = "RGB";
		var focalPointRatio = 0;
		var matrix = new Matrix();
		matrix.createGradientBox(240, 180, p[8]*__PI/180, 0, 0);
		ob.clear();
		ob.beginGradientFill(fillType, colors, alphas, ratios, matrix, spreadMethod, interpolationMethod, focalPointRatio);
		ob.moveTo(0, 0);
		ob.lineTo(0, 180);
		ob.lineTo(240, 180);
		ob.lineTo(240, 0);
		ob.lineTo(0, 0);
		ob.endFill();
		//}
		_activeObject = ob;
		_activeGrad = ob;
	}
	function addVideoOp(p) {
		if (p[1] == "clear") {
			//fn({name:"clear"});
			if (p[0] == "prev") {
				_global.FLAXUS_VIDEO.addPrev({name:"clear"});
			} else if (p[0] == "post") {
				_global.FLAXUS_VIDEO.addPost({name:"clear"});
			}
		} else if (p[1] == "drawImage") {
			if (p[0] == "prev") {
				_global.FLAXUS_VIDEO.addPrev({name:"drawImage", params:[p[2], p[3]]});
			} else if (p[0] == "post") {
				_global.FLAXUS_VIDEO.addPost({name:"drawImage", params:[p[2], p[3]]});
			}
		} else if (p[1] == "colorTrans") {
			if (p[0] == "prev") {
				_global.FLAXUS_VIDEO.addPrev({name:"colorTrans", params:[new ColorTransform(p[2], p[3], p[4], p[5], p[6], p[7], p[8], p[9]), p[10]]});
			} else if (p[0] == "post") {
				_global.FLAXUS_VIDEO.addPost({name:"colorTrans", params:[new ColorTransform(p[2], p[3], p[4], p[5], p[6], p[7], p[8], p[9]), p[10]]});
			}
		} else if (p[1] == "applyFilter") {
			if (p[2] == "ACTIVE_FILTER") {
				var f = _activeFilter.fil;
			} else if (typeof (p[2]) == "string") {
				var f = _filterCreated[p[2]].fil;
			} else {
				var f = p[2].fil;
			}
			if (p[0] == "prev") {
				_global.FLAXUS_VIDEO.addPrev({name:"applyFilter", params:[f, p[3]]});
			} else if (p[0] == "post") {
				_global.FLAXUS_VIDEO.addPost({name:"applyFilter", params:[f, p[3]]});
			}
		} else if (p[1] == "drawRender") {
			if (p[0] == "prev") {
				_global.FLAXUS_VIDEO.addPrev({name:"drawRender"});
			} else if (p[0] == "post") {
				_global.FLAXUS_VIDEO.addPost({name:"drawRender"});
			}
		} else if (p[1] == "saveRender") {
			if (p[0] == "prev") {
				_global.FLAXUS_VIDEO.addPrev({name:"saveRender", params:[p[2], p[3]]});
			} else if (p[0] == "post") {
				_global.FLAXUS_VIDEO.addPost({name:"saveRender", params:[p[2], p[3]]});
			}
		} else if (p[1] == "drawFromBuffer") {
			if (p[0] == "prev") {
				_global.FLAXUS_VIDEO.addPrev({name:"drawFromBuffer", params:[p[2], p[3]]});
			} else if (p[0] == "post") {
				_global.FLAXUS_VIDEO.addPost({name:"drawFromBuffer", params:[p[2], p[3]]});
			}
		}
	}
	function createVideoBuffer(p) {
		_global.FLAXUS_VIDEO.createBuffer(p[0]);
	}
	function videoClrPrev() {
		_global.FLAXUS_VIDEO.clrPrev();
	}
	function videoClrPost() {
		_global.FLAXUS_VIDEO.clrPost();
	}
	function videoRenderModeNormal(p) {
		_global.FLAXUS_VIDEO.renderNormal = p[0];
		_global.FLAXUS_VIDEO.modeRender = p[1];
	}
	function vecToColor(p) {
		//(_global.FLGLCORE.FILL_R << 16 | _global.FLGLCORE.FILL_G << 8 | _global.FLGLCORE.FILL_B)
		return (Number(p[0]) << 16 | Number(p[1]) << 8 | Number(p[2]));
	}
	function setLink(p) {
		//0: tolink
		//1: x
		//2: y
		//3: z
		//4: rx
		//5: ry
		//6: rz
		if (typeof (p[0]) == "string") {
			var o = _modelsCreated[p[0]];
		} else {
			var o = p[0];
		}
		_activeModel.linkedModel = o;
		_activeModel.linkedTrans = {x:p[1], y:p[2], z:p[3], rx:p[4], ry:p[5], rz:p[6]};
		_activeModel.isLinked = true;
	}
	function disableLink() {
		_activeModel.isLinked = false;
	}
	function setColor(p) {
		if (p.length == 1) {
			var c = Number(p[0]);
			var r = int(c/(256*256));
			c = c%(256*256);
			var g = int(c/256);
			var b = c%256;
		} else {
			var r = Number(p[0]);
			var g = Number(p[1]);
			var b = Number(p[2]);
		}
		_activeModel.setColor(r, g, b);
		_currentColorModelR = r;
		_currentColorModelG = g;
		_currentColorModelB = b;
	}
	function setModColor(p) {
		if (p[0] == "true") {
			_activeModel.isColorVar = true;
		} else {
			_activeModel.isColorVar = false;
		}
		if (p[1] != null && p[1] != undefined) {
			_activeModel.modColorA = Number(p[1]);
		}
		if (p[2] != null && p[2] != undefined) {
			_activeModel.modColorB = Number(p[2]);
		}
	}
	function setAlpha(p) {
		_activeModel.alpha = p[0];
	}
	function setBlur(p) {
		//(blurX, blurY, quality) 
		_activeModel.setBlur(p[0], p[1], p[2]);
	}
	function Current_Color(p) {
		if (p.length == 1) {
			var c = p[0];
			var r = int(c/(256*256));
			c = c%(256*256);
			var g = int(c/256);
			var b = c%256;
			_currentColor = p[0];
			_currentColorModelR = r;
			_currentColorModelG = g;
			_currentColorModelB = b;
		} else {
			_currentColor = (p[0] << 16 | p[1] << 8 | p[2]);
			_currentColorModelR = p[0];
			_currentColorModelG = p[1];
			_currentColorModelB = p[2];
		}
	}
	function Vector(p) {
		var arr = [];
		for (var i = 0; i<p.length; i++) {
			arr[i] = p[i];
		}
		return arr;
	}
	function resetGlobal() {
		_global.FLAXUS_EJE.setCoordinates(0, 0, 0);
		_global.FLAXUS_EJE.setRotation(0, 0, 0);
	}
	function _asignIDModel() {
		var nid = -1;
		for (var i in _modelsID_libres) {
			if (_modelsID_libres[i] == true) {
				nid = i;
				delete _modelsID_libres[i];
				break;
			}
		}
		if (nid == -1) {
			nid = _modelsID++;
		}
		return nid;
	}
	function _asignIDPlugin() {
		var nid = -1;
		for (var i in _pluginID_libres) {
			if (_pluginID_libres[i] == true) {
				nid = i;
				delete _pluginID_libres[i];
				break;
			}
		}
		if (nid == -1) {
			nid = _pluginID++;
		}
		return nid;
	}
	function _asignIDGrad() {
		var nid = -1;
		for (var i in _gradID_libres) {
			if (_gradID_libres[i] == true) {
				nid = i;
				delete _gradID_libres[i];
				break;
			}
		}
		if (nid == -1) {
			nid = _gradID++;
		}
		return nid;
	}
	function _asignIDFilter() {
		var nid = -1;
		for (var i in _filterID_libres) {
			if (_filterID_libres[i] == true) {
				nid = i;
				delete _filterID_libres[i];
				break;
			}
		}
		if (nid == -1) {
			nid = _filterID++;
		}
		return nid;
	}
	function clearScreen(p) {
		if (p[0] != null || p[0] != undefined) {
			_global.FLAXUS_VIDEO.colorBase = p[0];
		}
		_global.FLAXUS_VIDEO.clear();
	}
	function videoColorBase(p) {
		_global.FLAXUS_VIDEO.colorBase = p[0];
	}
	function clearTotal() {
		deleteAll();
		deleteAllDefinition();
		deleteAllVar();
		videoClrPrev();
		videoClrPost();
	}
	function Debug(p) {
		_global.FLAXUS_OUTPUT += newline+p[0];
	}
	function Tell(p) {
		_global.FLAXUS_OUTPUT += newline;
		if (_userMODO == 1) {
			_global.FLAXUS_OUTPUT += _userNAME+": ";
		}
		for (var i = 0; i<p.length; i++) {
			_global.FLAXUS_OUTPUT += " "+p[i];
		}
	}
	function login(p) {
		if (_userMODO == 0) {
			var yo = this;
			_user = p[0]
			_server = new NetConnection();
			_server.onStatus = function(info) {
				trace(info.code);
				if (info.code == "NetConnection.Connect.Success") {
					trace("Demo: Shared Object");
					yo._serverConected = true;
					yo._shared = SharedObject.getRemote("listaUsers", yo._server.uri);
					yo._shared.connect(yo._server);
					var yo2 = yo
					yo._shared.onSync = function(list) {
						for (var i = 0; i<list.length; i++) {
							trace(list[i].name+":"+list[i].code);
							if(list[i].code=="change"){
								_global.FLAXUS_OUTPUT += newline+"SERVER USER CONNECTED: "+list[i].name;
							}else if(list[i].code=="delete"){
								_global.FLAXUS_OUTPUT += newline+"SERVER USER DISCONNECTED: "+list[i].name;
							}
						}
						//change || delete
					};
					yo._shared.pasaCode = function  (code, user) {
						if(user != yo2._user){
							 _global.FLAXUS_NET = code
							_global.FLAXUS_PARSER(code,1,user);
						}
					}

					_global.FLAXUS_OUTPUT += newline+"SERVER CONECTED OK";
				}else if (info.code == "NetConnection.Connect.Close"){
					trace("Demo not available now! Try it later.");
					_global.FLAXUS_OUTPUT += newline+"SERVER LOGOUT";
				
				} else {
					trace("Demo not available now! Try it later.");
					_global.FLAXUS_OUTPUT += newline+"SERVER ERROR OR NAME DUPLICATED";
				}
			};
			_server.connect("rtmp://www.i2off.org/flaxus", p[0]);
		}
	}
	function logout(p) {
		if (_userMODO == 0) {
			_shared.close();
			_server.close();
			_serverConected = false;
		}
	}
}
